#include "../HFILES/header.h"
#include "../HFILES/initial_population.h"
#include "../HFILES/Movement.h"
#include "../HFILES/small_function.h"
#include "../HFILES/Information.h"
#include "../HFILES/Experiment.h"

main(int argc, char **argv)
{
PROFILE *Computer; 
int i,j,k;
time_t t;
int NumberNode,AvgDegree;
//int number = (int)pow(2,Wdsize);
int number = 2000;
//int *imporTance;
int No_of_Message = 100,TempStore;
int Count;
int No_of_Message_Uni;
int **RandomNode;
int MessageCount;
int FullCoverage,HalfCoverage;
int Full = 0, Half = 0;
int FullC = 0, HalfC = 0;
ESSIN *EssentialInformation;//**RandomInformation;
int *TempData;
int total_words,*TempSelection;
int QL;

/*********Variables read from the input file *********/
FILE *fp;
int RPM,PM,RW,RRW,HDRRW;
int HowManyTimes = 200;
int HowManyRounds;
char TopoFile[20];
int Exper;


k=(unsigned)time(&t);
srand(k);

if(argc != 2)
        {
        printf("FileName\n");
        exit(0);
        }

/*********input File Read*****************/

fp = fopen(argv[1],"r");

fscanf(fp,"%s",TopoFile);
//printf("%s ",TopoFile);
fscanf(fp,"%d",&NumberNode);
//printf("%d ",NumberNode);
fscanf(fp,"%d",&Exper);
//printf("%d ",Exper);
fscanf(fp,"%d",&HowManyTimes);
//printf("%d ",HowManyTimes);
fscanf(fp,"%d",&HowManyRounds);
//printf("%d ",HowManyRounds);
fscanf(fp,"%d",&REAL);
fscanf(fp,"%d",&KEYWORD);
fscanf(fp,"%f",&PROLI_RATE);
//printf("%f ",PROLI_RATE);
fscanf(fp,"%f",&MUTAT_RATE);
//printf("%f ",MUTAT_RATE);
fscanf(fp,"%d%d%d%d%d",&RPM,&PM,&RW,&RRW,&HDRRW);
//printf(" %d %d %d %d %d ",RPM,PM,RW,RRW,HDRRW);

fclose(fp);

/***************Topology File Reading **********************/

TempData = (int *)calloc(NumberNode,sizeof(int));
//printf("\n\n File_name = %s Proliferation Rate %f, ALPHA %f, Number Node - %d, RunNumber - %d, Wordlength - %d RandomLength - %d ", argv[1],PROLI_RATE,ALPHA,NumberNode, HowManyTimes, Wdsize, RSLen);
READFIRST(TopoFile,TempData);
Computer = (PROFILE *)calloc(NumberNode,sizeof(PROFILE));
for(i = 0;i<NumberNode; i++)
		(Computer+i)->neighborhood = (int *)calloc(TempData[i] + 1,sizeof(int));
READ(TopoFile,Computer);



if(REAL)/************ Data insertion ; for real *********************/
{
total_words = KEYWORD * NumberNode;
total_words +=  0.1 * total_words;
TempSelection = (int *)calloc(total_words,sizeof(int));
GenerateInformationProfile(TempSelection,number,KEYWORD,NumberNode,Computer);
/*for(i = 0; i < total_words; i++)
	printf("%d ", TempSelection[i]);
free(TempData);*/
}
else /**************This is for the simple data representation ***********/
{
total_words = NumberNode;
number = (int)pow(2,KEYWORD);
Wdsize = KEYWORD;
KEYWORD = 1;
TempSelection = (int *)calloc(total_words,sizeof(int));
GenerateInformationProfileSimple(TempSelection,number,KEYWORD,NumberNode,Computer);
}
printf("\n");

/********Most Probably not needed check later ************
PRINT(Computer,NumberNode);
exit(0);
*/
/****** This is the array which is shuffled everytime *******/
RandomSequence = (int *)calloc(NumberNode,sizeof(int));
for(i = 0; i < NumberNode; i++)
	RandomSequence[i] = i;

/***********Query Production ******************/
RandomNode = (int **)calloc(HowManyTimes,sizeof(int *));
for(Count = 0; Count < HowManyTimes; Count++)
{
if(REAL)
	QL = ChooseQueryLength();
else
	QL = 1;
RandomNode[Count] = (int *)calloc(QL+2,sizeof(int));
ChooseQueryAndNode(RandomNode[Count],TempSelection,QL,NumberNode,total_words);
/*for(i = 0; i < RandomNode[Count][1] + 2; i++)
	printf("%d ", RandomNode[Count][i]);
printf("\n");*/
}

//********************Coverage Calculation ********************

if(Exper)
{

	if(RPM)
	{
		printf("\n\n ******* Proliferation  with affinity driven function (without collision) ********\n\n");
		Produce(EssentialInformation, Computer, RandomNode,NumberNode, &No_of_Message, 1, HowManyTimes);
	}

	if(PM)
	{
		printf("\n\n ******* Proliferation with affinity driven function (with collision) ********\n\n");
		Produce(EssentialInformation, Computer, RandomNode,NumberNode, &No_of_Message, 3, HowManyTimes);
	}

	if(RRW)
	{
		printf("\n\n ******* Random Walk without collision  ********\n\n");
		//TempStore = No_of_Message;
		Produce(EssentialInformation, Computer, RandomNode,NumberNode, &No_of_Message, 4, HowManyTimes);
	}

	if(RW)
	{
		printf("\n\n ******* Random Walk with collision  ********\n\n");
		Produce(EssentialInformation, Computer, RandomNode,NumberNode, &No_of_Message, 5, HowManyTimes);
	}
}
else
{


//**************************** Time Step Calculation *************************//


	if(RPM)
	{
		printf("\n\n ******* Proliferation  with affinity driven function (without collision) ********\n\n");
		TimeStepProduce(Computer, RandomNode,NumberNode, &No_of_Message, 1, HowManyTimes, HowManyRounds);
	}
	if(PM)
	{
		printf("\n\n ******* Proliferation with affinity driven function (with collision) ********\n\n");
		TimeStepProduce(Computer, RandomNode,NumberNode, &No_of_Message, 3, HowManyTimes, HowManyRounds);
	}
	if(RRW)
	{
		printf("\n\n ******* Random Walk without collision  ********\n\n");
		TimeStepProduce(Computer, RandomNode,NumberNode, &No_of_Message, 4, HowManyTimes, HowManyRounds);
	}
	if(RW)
	{
		printf("\n\n ******* Random Walk with collision  ********\n\n");
		TimeStepProduce(Computer, RandomNode,NumberNode, &No_of_Message, 5, HowManyTimes, HowManyRounds);
	}
}

for(i=0; i < HowManyTimes; i++)
	free(RandomNode[i]);
free(RandomNode);
free(TempSelection);
for(i = 0;i<2; i++)
	free((Computer+i)->InformationSpace[i]);
free((Computer+i)->InformationSpace);
for(i = 0;i<NumberNode; i++)
	free((Computer+i)->neighborhood);
free(Computer);
free(RandomSequence);
}
